type 'a stream = Nil | Cons of 'a * 'a stream Lazy.t
  
let force = function lazyValue ->
  (match !lazyValue with
    | Lazy.Delayed _ -> print_endline "force" 
    | _ -> ()
  ) ;  
  Lazy.force lazyValue

let rec (++) = fun s1 s2 ->
  match s1 with
    | Nil -> s2
    | Cons (head, tail) -> Cons (head, lazy (force tail ++ s2))
